<?xml version="1.0"?>
<!--

  This stylesheet converts an XML file as output by peng into an input
  file for peng or Penguin 2.x.

  Usage:
    peng -Xs >somefile.xml
    xsltproc peng.xsl somefile.xml >somefile.txt
    peng -rs <somefile.xml
  or
    peng -X
    xsltproc peng.xsl torpspec.xml >torpdat.txt
    ...
    xsltproc peng.xsl hullspec.xml >hulldat.txt
    peng -r

-->
<xsl:stylesheet version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

 <!-- section names in multi-file thing -->
 <xsl:template match="shiplist/truehull">

% truehull
<xsl:apply-templates />
  <xsl:if test="./player"><xsl:call-template name="do-players" /></xsl:if>
  <xsl:if test="not(player)">

# You must remove the hash ("#") for this option to take effect
# PlayerRace = 1,2,3,4,5,6,7,8,9,10,11</xsl:if>
 </xsl:template>
 <xsl:template match="shiplist/engines">

% engines
<xsl:apply-templates />
 </xsl:template>
 <xsl:template match="shiplist/beams">

% beams
<xsl:apply-templates />
 </xsl:template>
 <xsl:template match="shiplist/torps">

% torps
<xsl:apply-templates />
 </xsl:template>
 <xsl:template match="shiplist/hulls">

% hulls
<xsl:apply-templates />
 </xsl:template>
 <xsl:template match="truehull">
  <xsl:apply-templates />
  <xsl:if test="./player"><xsl:call-template name="do-players" /></xsl:if>
 </xsl:template>

 <xsl:output method="text" encoding="iso-8859-1" />

 <!-- truehull entries -->
 <xsl:template match="race">
Player       = <xsl:value-of select="@n" />
Ships        = <xsl:for-each select="racehull">
                <xsl:if test="not(position()=1)">,</xsl:if>
                <xsl:value-of select="@n" />
               </xsl:for-each>
</xsl:template>

 <!-- engspec entries -->
 <xsl:template match="engine">
Engine       = <xsl:value-of select="@n" />
  <xsl:apply-templates />
  <xsl:text xml:space="preserve">
</xsl:text>
 </xsl:template>

 <!-- hullspec entries -->
 <xsl:template match="hull">
Hull         = <xsl:value-of select="@n" />
  <xsl:apply-templates />
  <xsl:text xml:space="preserve">
</xsl:text>
 </xsl:template>

 <!-- beamspec entries -->
 <xsl:template match="beam">
Beam         = <xsl:value-of select="@n" />
  <xsl:apply-templates />
  <xsl:text xml:space="preserve">
</xsl:text>
 </xsl:template>

 <!-- torpspec entries -->
 <xsl:template match="torp">
Tube         = <xsl:value-of select="@n" />
  <xsl:apply-templates />
  <xsl:text xml:space="preserve">
</xsl:text>
 </xsl:template>

 <!-- parameters -->
 <xsl:template match="name">
Name         = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="cost">
Cost         = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="torp/cost">
TubeCost     = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="torpcost">
TorpedoCost  = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="tri">
Tritanium    = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="dur">
Duranium     = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="mol">
Molybdenum   = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="tech">
Techlevel    = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="fuelusage/warp">
FuelUsage    = <xsl:value-of select="@n" />, <xsl:value-of select="@v" />
 </xsl:template>

 <xsl:template match="pic">
Picture      = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="fuel">
FuelTank     = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="cargo">
CargoSpace   = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="crew">
Crew         = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="nengines">
Engines      = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="mass">
Mass         = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="nbeams">
BeamWeapons  = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="ntubes">
TorpedoTubes = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="nbays">
FighterBays  = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="kill">
Kill         = <xsl:value-of select="text()" />
 </xsl:template>

 <xsl:template match="damage">
Damage       = <xsl:value-of select="text()" />
 </xsl:template>
 
 <!-- generic stuff -->
 <xsl:template match="text()">
 </xsl:template>

 <xsl:template name="do-players">
PlayerRace = <xsl:value-of select="player[@n='1']/@race" />,<xsl:value-of select="player[@n='2']/@race" />,<xsl:value-of select="player[@n='3']/@race" />,<xsl:value-of select="player[@n='4']/@race" />,<xsl:value-of select="player[@n='5']/@race" />,<xsl:value-of select="player[@n='6']/@race" />,<xsl:value-of select="player[@n='7']/@race" />,<xsl:value-of select="player[@n='8']/@race" />,<xsl:value-of select="player[@n='9']/@race" />,<xsl:value-of select="player[@n='10']/@race" />,<xsl:value-of select="player[@n='11']/@race" />
 </xsl:template>
 
 
</xsl:stylesheet>